;; (require 'chicken)

(setq print-length nil
      eval-expression-print-length nil)

;; (require 'slime)
(require 'slime-autoloads)
(global-set-key (kbd "<f5> s") 'slime)
(with-eval-after-load 'slime
  (slime-setup)
  (setq inferior-lisp-program
        ;; "/usr/bin/sbcl"
        "/usr/bin/ecl"
        )
  (cp-set-keys
   :keymap slime-mode-map
   :bindings
   `((,(kbd "M-n")   next-line)
     (,(kbd "M-p")   previous-line)
     (,(kbd "SPC")   self-insert-command))))

(defun set-cl-repl-keys ()
  (if (or (cp-buffer-name-match-p "^\*inferior-lisp\*\\(<[0-9]*>\\)?")
          (eq major-mode 'lisp-mode))
      (progn
        (local-set-key (kbd "TAB") 'completion-at-point)
        (local-set-key (kbd "M-q") 'sp-indent-defun))))

(add-hook 'slime-connected-hook 'set-cl-repl-keys)
(add-hook 'comint-mode-hook     'set-cl-repl-keys)
(add-hook 'lisp-mode-hook       'set-cl-repl-keys)

(setq scheme-program-name "csi -:c")
(setq comint-prompt-read-only t)

(add-to-list 'auto-mode-alist '("\\.scm\\'" . scheme-mode))
;; (add-to-list 'auto-mode-alist '("\\.scm\\'" . geiser-mode))
;; (require 'geiser)

(use-package geiser
  :commands (run-chicken run-guile geiser-mode))
;; (with-eval-after-load 'geiser-mode
;;   (setq geiser-mode-smart-tab-p t)
;;   (define-key geiser-mode-map (kbd "C-.") nil)
;;   ;; (cp-set-keys
;;   ;;  :unset t
;;   ;;  :keymap geiser-mode-map
;;   ;;  :bindings
;;   ;;  `((,(kbd "C-."))))
;;   )

(use-package scheme-mode
  :defer t
  :interpreter "csi")

(defun contrapunctus-lisp-copy (arg)
  "Run `whole-line-or-region-copy-region-as-kill' if region is
active, else `sp-copy-sexp'."
  (interactive "P")
  (if (region-active-p)
      (whole-line-or-region-copy-region-as-kill arg)
    (sp-copy-sexp arg)))

(use-package elisp-mode
  :diminish
  :bind (:map emacs-lisp-mode-map
              ("<tab>" . completion-at-point)))

(use-package eldoc
  :diminish
  :if (featurep 'elisp-mode)
  :init (add-hook 'emacs-lisp-mode-hook 'eldoc-mode)
  :config (setq eldoc-idle-delay 0))

(defun colorize-compilation-buffer ()
  (ansi-color-apply-on-region compilation-filter-start
			      (point)))

(add-hook 'compilation-filter-hook 'colorize-compilation-buffer)

(update-file-autoloads "~/.emacs.d/elisp-git/clojure-mode/clojure-mode.el"
                       t
                       "~/.emacs.d/elisp-git/clojure-mode/clojure-autoloads.el")
(load "clojure-autoloads")
;; (autoload 'clojure-mode "clojure-mode" nil t)
(with-eval-after-load "clojure-mode"
  (require 'cider))

(use-package nameless
  :ensure t
  :commands nameless-mode
  :init
  (add-hook 'emacs-lisp-mode-hook  'nameless-mode)
  (add-hook 'ert-results-mode-hook 'nameless-mode)
  :bind (:map emacs-lisp-mode-map
              ("C-c C-n" . nameless-mode)))
(provide 'cp-lisp)
